#ifndef C_UTILS_WORKQUEUE_H
#define C_UTILS_WORKQUEUE_H

typedef struct workqueue_t workqueue_t;

typedef int (*workqueue_function_t) (void * data);

int workqueue_create (workqueue_t * q);
int workqueue_destroy (workqueue_t * q);

/**
 * Put an entry on the workqueue.
 * Returns non-zero for success, zero otherwise.
 */
int workqueue_push (workqueue_t * q, workqueue_function_t * f, void * data);

/** Remove an entry from the workqueue; Returns 1 if success, 0 if the queue
 * was empty or other error */
int workqueue_pop (workqueue_t * q, workqueue_function_t ** f, void ** data);

#endif
