/*
 * (C) 2009 The University of Chicago
 *
 * See COPYRIGHT in top-level directory.
 */

#ifndef __TEST_TAP
#define __TEST_TAP

#include <stdio.h>
#include <assert.h>

#define tap_begin(__testcount, __failcount) \
do {\
    __testcount = 1; \
    __failcount = 0; \
}while(0)

#define tap(__name, __expr, __testcount, __failcount) \
do { \
    assert(__testcount > 0); \
    if(__expr) { \
        printf("ok %d - %s\n", __testcount, __name); \
    }\
    else {\
        printf("not ok %d - %s\n", __testcount, __name); \
        printf("  # failed condition: " #__expr "\n"); \
        __failcount++; \
    }\
    __testcount++; \
}while(0)

#define tap_end(__testcount, __failcount) \
do {\
    printf("1..%d\n", __testcount-1); \
}while(0)


#endif /* __TEST_TAP */

/*
 * Local variables:
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ts=8 sts=4 sw=4 expandtab
 */
