/*
 * (C) 2009 The University of Chicago
 *
 * See COPYRIGHT in top-level directory.
 */

/* test program to exercies uint128_t utility functions */

#include <stdlib.h>
#include <string.h>
#include "triton-uint128.h"
#include "test-tap.h"

int main(int argc, char *argv[])
{
    uint128_t big;
    char *big_str;
    int testcase, failcount;

    tap_begin(testcase, failcount);

    big = triton_uint128_from_uint64(0);
    big_str = triton_uint128_to_string(big);
    tap("triton_uint128_from_uint64(0)", strcmp(big_str, "::") == 0,
        testcase, failcount);
    if (big_str) free(big_str);

    big = triton_uint128_inc(big);
    big_str = triton_uint128_to_string(big);
    tap("triton_uint128_inc(0)", strcmp(big_str, "::1") == 0,
        testcase, failcount);
    if (big_str) free(big_str);

    big = triton_uint128_from_uint64(UINT64_MAX);
    big_str = triton_uint128_to_string(big);
    tap("triton_uint128_from_uint64(UINT64_MAX)", big.l == UINT64_MAX,
        testcase, failcount);
    if (big_str) free(big_str);

    big = triton_uint128_inc(big);
    big_str = triton_uint128_to_string(big);
    printf("%s\n", big_str);
    tap("triton_uint128_inc(UINT64_MAX)", strcmp(big_str, "0:0:0:1::") == 0,
        testcase, failcount);
    if (big_str) free(big_str);

    tap_end(testcase, failcount);

    if(failcount)
        return(-1);
    else
        return(0);
}

/*
 * Local variables:
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ts=8 sts=4 sw=4 expandtab
 */
